#include "DataField.h"

#include "DataValue.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

DataField *createDataField()
{
	DataField *toReturn = (DataField*) malloc(sizeof(DataField));
	toReturn->numData = 0;
	toReturn->display = 1;
	toReturn->name = NULL;
    
    toReturn->minData = NULL;
    toReturn->maxData = NULL;
	
	return toReturn;
}


void dataFieldCopyName(DataField *dataField, const char *source)
{
	if (dataField->name != NULL){
		free(dataField->name);
	}

	dataField->name = (char*) malloc(strlen(source) + 1);

	strcpy(dataField->name, source);
}


void dataFieldAddData(DataField *dataField, DateTime *dateTime, float value){
	dataField->data[dataField->numData] = createDataValue(dateTime, value);
	
	dataField->numData++;
}


void printDataField(DataField *dataField){
	int i = 0;
	
	printf("%s\n", dataField->name);
	for(i = 0; i < dataField->numData; i++){
		printf("     ");
		printDataValue(dataField->data[i]);
		printf("\n");
	}
}

DataValue *getDataFieldMin(DataField *field) {
    int i = 0;
    
    if(field->minData == NULL) {
        
        field->minData = field->data[0];
        
        for(i = 1; i < field->numData; i++){
            if(field->data[i]->value < field->minData->value) {
                field->minData = field->data[i];
            }
        }
    }
    
    return field->minData;
}

DataValue *getDataFieldMax(DataField *field) {
    int i = 0;    
    
    if(field->maxData == NULL) {
        
        field->maxData = field->data[0];
        
        for(i = 1; i < field->numData; i++){
            if(field->data[i]->value > field->maxData->value) {
                field->maxData = field->data[i];
            }
        }
    }
    
    return field->maxData;
}

/**
 * This function pads out a data array
 *
void applyDataPointPadding(DataField *field, char *padding, int numInPadding) {
    int oldDataLen = field->numData;
    
    for(int i = numInPadding-1; i >= 0; i--) {
        
    }
}*/
