#ifndef DATAFIELD_H_
#define DATAFIELD_H_

#include "DataValue.h"
#include "DateTime.h"
#include <string.h>

#define MAX_NUM_DATA 10000

typedef struct struct_dataField
{
	char *name;
	DataValue *data[MAX_NUM_DATA];
	int numData;
	int display;
    
    // These caches values make it this structure read only
    DataValue *minData;
    DataValue *maxData;
} DataField;

DataField *createDataField();
void dataFieldCopyName(DataField *dataField, const char *name);
void dataFieldAddData(DataField *dataField, DateTime *dateTime, float value);
void printDataField(DataField *dataField);

DataValue *getDataFieldMax(DataField *field);
DataValue *getDataFieldMin(DataField *field);

#endif /*DATAFIELD_H_*/
