#include "DateTime.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/*
DateTime::DateTime(){
}
*/

DateTime *createDateTime(char *dateTimeStrOrg)
{
	char* curPos;
	DateTime *toReturn = (DateTime*) malloc(sizeof(DateTime));
	
	char dateTimeStr[DATE_TIME_STR_LEN + 1];
	strcpy(dateTimeStr, dateTimeStrOrg);
	
	//2007-09-18 18:58:39.375000
	curPos = dateTimeStr;
	
	curPos[YEAR_LEN] = '\0';
	toReturn->year = atoi(curPos);
	curPos += YEAR_LEN + 1;
	
	curPos[MONTH_LEN] = '\0';
	toReturn->month = atoi(curPos);
	curPos += MONTH_LEN + 1;
	
	curPos[DAY_LEN] = '\0';
	toReturn->day = atoi(curPos);
	curPos += DAY_LEN + 1;
	
	curPos[HOUR_LEN] = '\0';
	toReturn->hour = atoi(curPos);
	curPos += HOUR_LEN + 1;
	
	curPos[MINUTE_LEN] = '\0';
	toReturn->minute = atoi(curPos);
	curPos += MINUTE_LEN + 1;
	
	toReturn->seconds = atoi(curPos);
	
	return toReturn;
}

void printDateTime(DateTime *dateTime)
{
	printf("%d-%d-%d %d:%d:%d", dateTime->year, dateTime->month, dateTime->day, dateTime->hour, dateTime->minute, dateTime->seconds);
}

void printDateTimeToArray(DateTime *dateTime, char *array)
{
    sprintf(array, "%d/%d/%d %d:%d:%d", dateTime->month, dateTime->day, dateTime->year, dateTime->hour, dateTime->minute, dateTime->seconds);
    
    int curStrLen = strlen(array);
    
    if(array[curStrLen-2] == ':'){
        // Shift
        array[curStrLen+1] = '\0';
        array[curStrLen] = array[curStrLen-1];
        array[curStrLen-1] = '0';
        
        curStrLen++;
    }
    
    if(array[curStrLen-5] == ':'){
        // Shift
        array[curStrLen+1] = '\0';
        array[curStrLen] = array[curStrLen-1];
        array[curStrLen-1] = array[curStrLen-2];
        array[curStrLen-2] = array[curStrLen-3];
        array[curStrLen-3] = array[curStrLen-4];
        array[curStrLen-4] = '0';
    }
    
}

void printTimeToArray(DateTime *dateTime, char *array)
{
    sprintf(array, "%d:%d:%d", dateTime->hour, dateTime->minute, dateTime->seconds);
}

int timeToSeconds(DateTime *dateTime)
{
    return (dateTime->hour*3600) + (dateTime->minute*60) + dateTime->seconds;
}
