#include "Earth.h"

#include <GL/glut.h>
#include <stdlib.h>

#include "DateTime.h"
#include "Globals.h"
#include "Pass.h"
#include "TextureUtils.h"
#include "Textures.h"
#include "Utils.h"

GLUquadricObj* earthSphere;

void drawEarth(Earth *earth, float x, float y, float z){
	unsigned int timeThatHasPast;

    glPushMatrix();

        glTranslatef(x,y,z);
        
        timeThatHasPast = timeToSeconds(earth->pass->startOfPass) - timeToSeconds(earth->pass->fields[0]->data[curSelectedIndex]->dateTime);
        //(1.0/(24.0*60.0*60.0) is the rate the earth turns
        glRotatef(360.0 * (timeThatHasPast) * (1.0/(24.0*60.0*60.0)), 0.0, 0.0, 1.0);
    

        glDisable(GL_LIGHTING);
        
        glEnable(GL_TEXTURE_2D);
        
        glBindTexture(GL_TEXTURE_2D, TEXTURE_EARTH);

        gluSphere(earthSphere, EARTH_RADIUS, EARTH_RESOLUTION, EARTH_RESOLUTION);
        
        glDisable(GL_TEXTURE_2D);
        glEnable(GL_LIGHTING);
    
    glPopMatrix();
}

Earth *createEarth(Pass *passToSet){
    Earth *toReturn = (Earth*) malloc(sizeof(Earth));    
    
    toReturn->pass = passToSet;
    
    //create a sphere
    earthSphere = gluNewQuadric();
    gluQuadricDrawStyle(earthSphere, GLU_FILL);
    //make opengl generate the texture coordinates for the sphere
    gluQuadricTexture(earthSphere, GL_TRUE);
    
    return toReturn;
}
