#ifndef ORBIT_H_
#define ORBIT_H_

#include "DataField.h"
#include "Pass.h"

#define ORBIT_PERIOD  5880.0 // In seconds

#define ORBIT_MIN_SIZE 10.0
#define ORBIT_MAX_SIZE 100.0
#define ORBIT_DEFAULT_SIZE 25.0

// This value is half of the bar with
#define ORBIT_BAR_WIDTH 2.0

typedef struct structOrbit {
    Pass *pass;
    
    float inclination;
    float altitude;
    float period;

} Orbit;

// Orbit drawing modes
typedef enum orbitDrawingModes {
      ORBIT_DRAW_BAR, ORBIT_DRAW_SPHERE
} OrbitDrawingMode;

extern OrbitDrawingMode orbitDrawingMode;

Orbit *createOrbit(Pass *pass, float inc, float alt, float per);
void drawOrbit(Orbit *orbit, float x, float y, float z);

void cycleOrbitDrawType();

#endif /*ORBIT_H_*/
