#ifndef PASS_H_
#define PASS_H_

#include "DataField.h"

#define MAX_NUM_FIELDS 500
//#define PASS_DATA_INTERVAL  120.0 // 2 minutes
#define PASS_DATA_INTERVAL  30.0 // 30 seconds

typedef struct struct_pass{
	DataField *fields[MAX_NUM_FIELDS];
    char dateTimeStr[1000];
	int numFields;
    int numDataPoints;
    DateTime *startOfPass;
    float interval;   // The data interval in seconds
} Pass;

Pass *createPass(const char *inputFile);
void printPass(Pass *pass);
DateTime *getPassStartTime(Pass *pass);
void swapPassDataFields(Pass *pass, int toSwap1, int toSwap2);
DateTime *getTimeForDataFieldIndex(Pass *pass, int index);

void unshowAllFields(Pass *pass);
void showAllFields(Pass *pass);

#endif /*PASS_H_*/
