#include "StarField.h"

#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>

#include "Utils.h"

StarField *createStarField(int halfHeight, int halfWidth, int halfDepth) {
    int i = 0;
    StarField *toReturn = (StarField*) malloc(sizeof(StarField));
    
    for(i = 0; i < NUM_OF_STARS; i++){
        
        // Top
        if(i % 6 == 0){
            toReturn->locations[i].x = randNumBetween(-halfWidth,halfWidth);
            toReturn->locations[i].y = halfHeight;
            toReturn->locations[i].z = randNumBetween(-halfDepth,halfDepth);
        }
        
        // Bottom
        else if(i % 6 == 1){
            toReturn->locations[i].x = randNumBetween(-halfWidth,halfWidth);
            toReturn->locations[i].y = -halfHeight;
            toReturn->locations[i].z = randNumBetween(-halfDepth,halfDepth);
        }
        
        // Left
        else if(i % 6 == 2){
            toReturn->locations[i].x = -halfWidth;
            toReturn->locations[i].y = randNumBetween(-halfHeight,halfHeight);
            toReturn->locations[i].z = randNumBetween(-halfDepth,halfDepth);
        }
        
        // Right
        else if(i % 6 == 3){
            toReturn->locations[i].x = halfWidth;
            toReturn->locations[i].y = randNumBetween(-halfHeight,halfHeight);
            toReturn->locations[i].z = randNumBetween(-halfDepth,halfDepth);
        }
        
        // Front
        else if(i % 6 == 4){
            toReturn->locations[i].x = randNumBetween(-halfWidth,halfWidth);
            toReturn->locations[i].y = randNumBetween(-halfHeight,halfHeight);
            toReturn->locations[i].z = -halfDepth;
        }
        // Back
        else if(i % 6 == 5){
            toReturn->locations[i].x = randNumBetween(-halfWidth,halfWidth);
            toReturn->locations[i].y = randNumBetween(-halfHeight,halfHeight);
            toReturn->locations[i].z = halfDepth;
        }
        
        toReturn->radius[i] = randNumBetween(STAR_MIN_RADIUS,STAR_MAX_RADIUS);
    }

    return toReturn;
}

void drawStarField(StarField *starField) {
    int i = 0;
    
    
    glColor3f(1.0,1.0,1.0);
    
    for(i = 0; i < NUM_OF_STARS; i++) {
        
        glPushMatrix();

        glTranslatef(starField->locations[i].x, starField->locations[i].y, starField->locations[i].z);
        glutSolidSphere(starField->radius[i],3,3);

        glPopMatrix();
    }
}

void printStarField(StarField *starField){
    int i = 0;
    for(i = 0; i < NUM_OF_STARS; i++){
        printf("(%f,%f,%f) -> %f \n", starField->locations[i].x,starField->locations[i].y,starField->locations[i].z,starField->radius[i]);
    }
}
